//+-------------------------------------------------------------------+
//|                                                  Line Trader.mq4  |
//|                                     Copyright 2019, Reza Pratama  |
//|                                             https://www.mql5.com  |
//| Change Log                                                        |
//| V.1   Inisial Release                                             |
//|       Open Buy bila harga di bawah garis dan close di atas garis  |
//|       Open Sell bila harga di atas garis dan close di bawah garis |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, Reza Pratama"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
double TPSell,TPBuy,OpenBuy,OpenSell;
string CommentBuy,CommentSell,CommentOpenSell,CommentOpenBuy;
double Lot;
double MagicOrderBuy,MagicOrderSell;
double CloseBuy,CloseSell;
double JarakAman;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
TPSell=ObjectGetValueByTime(0,"TPSell",TimeCurrent(),0);
TPBuy=ObjectGetValueByTime(0,"TPBuy",TimeCurrent(),0);
OpenBuy=ObjectGetValueByTime(0,DoubleToString(MagicOrderBuy,0),TimeCurrent(),0);
OpenSell=ObjectGetValueByTime(0,DoubleToString(MagicOrderSell,0),TimeCurrent(),0);
Lot=GlobalVariableGet(Symbol()+"_Lot");
if(Lot==0)GlobalVariableSet(Symbol()+"_Lot",MarketInfo(Symbol(),MODE_MINLOT));
MagicOrderBuy=GlobalVariableGet(Symbol()+"_MagicOrderBuy");
if(!GlobalVariableCheck(Symbol()+"_MagicOrderBuy"))GlobalVariableSet(Symbol()+"_MagicOrderBuy",1);
MagicOrderSell=GlobalVariableGet(Symbol()+"_MagicOrderSell");
if(!GlobalVariableCheck(Symbol()+"_MagicOrderSell"))GlobalVariableSet(Symbol()+"_MagicOrderSell",2);

JarakAman=GlobalVariableGet(Symbol()+"_Jarak");
if(!GlobalVariableCheck(Symbol()+"_Jarak"))GlobalVariableSet(Symbol()+"_Jarak",30);

CloseBuy=GlobalVariableGet(Symbol()+"_CloseBuy");
if(!GlobalVariableCheck(Symbol()+"_CloseBuy"))GlobalVariableSet(Symbol()+"_CloseBuy",0);
CloseSell=GlobalVariableGet(Symbol()+"_CloseSell");
if(!GlobalVariableCheck(Symbol()+"_CloseSell"))GlobalVariableSet(Symbol()+"_CloseSell",0);
CommentBuy="";
CommentSell="";
CommentOpenBuy="";
CommentOpenSell="";
//------------Open Order--------------
if(OpenBuy !=0 && CekOpen(1,(int)MagicOrderBuy)==0){
   CommentOpenBuy="Open Order Buy bila harga di bawah "+DoubleToString(OpenBuy,Digits)+" dengan Lot Sebesar "+DoubleToString(Lot,2)+" Jarak masih "+DoubleToString((MathAbs(Ask-OpenBuy)/Point)/10,0)+" Pips"; 
   if(Ask < OpenBuy && MathAbs(Ask-OpenBuy)/Point < JarakAman && CekOpen(1,(int)MagicOrderBuy)==0)OpenOrder(1,(int)MagicOrderBuy);
}
if(OpenSell !=0 && CekOpen(2,(int)MagicOrderSell)==0){
   CommentOpenSell="Open Order Sell bila harga di atas "+DoubleToString(OpenSell,Digits)+" dengan Lot Sebesar "+DoubleToString(Lot,2)+" Jarak masih "+DoubleToString((MathAbs(Bid-OpenSell)/Point)/10,0)+" Pips"; 
   if(Bid > OpenSell && MathAbs(Bid-OpenSell)/Point < JarakAman && CekOpen(2,(int)MagicOrderSell)==0)OpenOrder(2,(int)MagicOrderSell);
}
//---------------------------------------
//--------Close Order-------------------------
if(CekClose(1)>0 && TPBuy != 0){
   CommentBuy="Take Profit Buy di harga "+DoubleToString(TPBuy,Digits);
   if(Bid > TPBuy && CekProfit(1) > 0)GlobalVariableSet(Symbol()+"_CloseBuy",1);
}
if(CekClose(2)>0 && TPSell != 0){
   CommentSell="Take Profit Sell di harga "+DoubleToString(TPSell,Digits);
   if(Ask < TPSell && CekProfit(2) > 0)GlobalVariableSet(Symbol()+"_CloseSell",1);
}

if(CloseBuy == 1){
   if(CekClose(1) > 0)CloseOrder(1);
   if(CekClose(1) == 0)GlobalVariableSet(Symbol()+"_CloseBuy",0);
   }
if(CloseSell == 1 ){
   if(CekClose(2) > 0)CloseOrder(2);
   if(CekClose(2) == 0)GlobalVariableSet(Symbol()+"_CloseSell",0);
   }

//------------------------------------------------

Comment(CommentOpenBuy,"\n",CommentOpenSell,"\n",CommentBuy,"\n",CommentSell);
   RefreshRates();
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
int OpenOrder(int TipeOrder,int Magic){
   int Ticket;
   if(TipeOrder==1){//OP_BUY
   Ticket=OrderSend(Symbol(),OP_BUY,Lot,Ask,10,0,0,"",Magic,0,clrGreen);
   if(Ticket<0)
      {
      Print("Error opening BUY order : ",GetLastError()); 
      }  
      else
      {
        
         Print("Buy Enter");
      }
   }
   if(TipeOrder==2){//OP_SELL
   Ticket=OrderSend(Symbol(),OP_SELL,Lot,Bid,10,0,0,"",Magic,0,clrRed);
   if(Ticket<0)
      {
      Print("Error opening SELL order : ",GetLastError()); 
      }  
      else
      {
         
         Print("Sell Enter");
      }
   }
return(0);
}
//+------------------------------------------------------------------+
//| Close For Open Position                                          |
//+------------------------------------------------------------------+
int CloseOrder(int TipeOrder){
int i;
    double op;

    for(i=0;i<OrdersTotal();i++)
    {
        if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) continue;   
        if(OrderSymbol()!=Symbol()) continue; 
        op = OrderOpenPrice();
        if(TipeOrder == 1){
        if(OrderType() == OP_BUY)
        {         
                if(!OrderClose(OrderTicket(),OrderLots(),Bid,3,clrViolet))
                    Print("OrderClose error ",GetLastError());
                break;
                                     
        } 
       }
       if(TipeOrder == 2){
        if(OrderType() == OP_SELL)
        {     
                if(!OrderClose(OrderTicket(),OrderLots(),Ask,3,clrViolet))
                    Print("OrderClose error ",GetLastError());
                break; 
                     
        } 
       }    
    }    
   
    return(0);
}
//+------------------------------------------------------------------+
//| Check For Open Position                                          |
//+------------------------------------------------------------------+
int CekOpen(int TipeOrder,int Magic){
int beli=0,jual=0;
//---
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_BUY && OrderMagicNumber()==Magic)  beli++;
         if(OrderType()==OP_SELL && OrderMagicNumber()==Magic) jual++;
        }
     }
//--- return orders volume
   if(TipeOrder==1) return(beli);
   else return(jual);
}
//+------------------------------------------------------------------+
//| Check For Close Position                                          |
//+------------------------------------------------------------------+
int CekClose(int TipeOrder){
int beli=0,jual=0;
//---
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_BUY)  beli++;
         if(OrderType()==OP_SELL) jual++;
        }
     }
//--- return orders volume
   if(TipeOrder==1) return(beli);
   else return(jual);
}
//+------------------------------------------------------------------+
//| Check For Profit                                          |
//+------------------------------------------------------------------+
double CekProfit(int Tipe){
double Profit=0;
//---
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol()){
      if(Tipe==1){
      if(OrderSymbol()==Symbol())
        Profit+=OrderProfit()+OrderCommission();
        }
        if(Tipe==2)Profit+=OrderProfit()+OrderCommission();
        }
     }
//--- return orders volume
   return(Profit);
}
